<template>
	<transition
		:enter-active-class="$style.enterActive"
		:leave-active-class="$style.leaveActive"
		:enter-class="$style.enter"
		:leave-to-class="$style.leaveTo"
		enter-to-class=""
		@enter="enter"
		@after-enter="afterEnter"
		@leave="leave"
	>
		<slot />
	</transition>
</template>

<script>
// Source: https://markus.oberlehner.net/blog/transition-to-height-auto-with-vue/

// Force repaint to make sure the animation is triggered correctly.
const forceRepaint = (el) => getComputedStyle(el).height;

export default {
	methods: {
		enter(el) {
			const { width } = getComputedStyle(el);

			el.style.width = width;
			el.style.position = 'absolute';
			el.style.visibility = 'hidden';
			el.style.height = 'auto';

			const { height } = getComputedStyle(el);

			el.style.width = null;
			el.style.position = null;
			el.style.visibility = null;
			el.style.height = 0;

			forceRepaint(el);

			requestAnimationFrame(() => (el.style.height = height));
		},

		afterEnter: (el) => (el.style.height = null),

		leave(el) {
			const { height } = getComputedStyle(el);

			el.style.height = height;

			forceRepaint(el);

			requestAnimationFrame(() => (el.style.height = '0'));
		},
	},
};
</script>

<style scoped>
/* optimize the performance by tricking the browser into using hardware acceleration */
* {
	will-change: height;
	transform: translateZ(0);
	backface-visibility: hidden;
	perspective: 1000px;
}
</style>

<style lang="scss" module>
@import '@design';

.enterActive,
.leaveActive {
	overflow: hidden;
	transition: height time('fast') ease('in'), opacity time('fast') ease('in');
}

.enter,
.leaveTo {
	height: 0;
	opacity: 0;
}
</style>
